﻿// CoverBuilder_CS5.jsx
// An InDesign CS5 Javascript
// Bruno Herfst 2011

/*

TO DO:
Make presets + (save)
Add flap Function
Save settingsinfo to file
Boxset tickbox

Reset swatches
Different script to place A&U Items. (Script to run both)
Different script to change Spine script
can’t fill in zero for flaps
add guide
*/


//----------------------------------- G L O B A L - V A R I A B L E S
var myCover,gWidth,fWidth,wWidth,gHeight,gSpine,myBleed,myFinish,myFlap;


//----------------------------------- M A I N

main();

function main(){
	
	//target the latest version of InDesign
	#target "InDesign"
	
	//Display Dialog
	dispDialog();

}

//----------------------------------- F U N C T I O N S

function dispDialog(){
	var myDialog = app.dialogs.add({name:"CoverBuilder CS5.5", canCancel:true});
	with(myDialog){
		//Add a dialog column.
		with(dialogColumns.add()){
			// N E W - R O W
			with(dialogRows.add()){
				with(dialogColumns.add()){
					staticTexts.add({staticLabel:"Width:"});
				}
				with(dialogColumns.add()){
					myInputWidth=mm2pt(128);
					var myWidthField = measurementEditboxes.add({editUnits: MeasurementUnits.MILLIMETERS,editValue:myInputWidth});
				}
				with(dialogColumns.add()){
					staticTexts.add({staticLabel:"Height:"});
				}
				with(dialogColumns.add()){
					myInputHeight=mm2pt(198);
					var myHeightField = measurementEditboxes.add({editUnits:MeasurementUnits.MILLIMETERS,editValue:myInputHeight});
				}
				with(dialogColumns.add()){
					staticTexts.add({staticLabel:"Spine:"});
				}
				with(dialogColumns.add()){
					myInputSpine=mm2pt(10);
					var mySpineField = measurementEditboxes.add({editUnits:MeasurementUnits.MILLIMETERS,editValue:myInputSpine});
				}
			}
			// N E W - R O W
			with(dialogRows.add()){
				with(dialogColumns.add()){
					var myBackSelection = ["Paperback","Hardback"];
					var hbpb = dropdowns.add({stringList:myBackSelection, selectedIndex:0});
				}
				with(dialogColumns.add()){
					var myFinishSelection = ["--No finish--","Gloss Lamination","Gloss Varnish","Matt Lamination","Matt Varnish"];
					var mfs = dropdowns.add({stringList:myFinishSelection, selectedIndex:0});
				}
			}
			// N E W - R O W
			with(dialogRows.add()){
				with(dialogColumns.add()){
					staticTexts.add({staticLabel:""});
				}
			}
			// N E W - R O W
			with(dialogRows.add()){
				//Create a border panel.
				with(borderPanels.add()){
					with(dialogColumns.add()){
						var myFlapCheckbox = checkboxControls.add({staticLabel:"Add flaps: ", checkedState:false});
					}
					with(dialogColumns.add()){
						staticTexts.add({staticLabel:" Width:"});
					}
					with(dialogColumns.add()){
						myInputWidth=mm2pt(50);
						var myFlapWidthField = measurementEditboxes.add({editUnits: MeasurementUnits.MILLIMETERS,editValue:myInputWidth});
					}
					with(dialogColumns.add()){
						staticTexts.add({staticLabel:"Wrap:"});
					}
					with(dialogColumns.add()){
						myInputHeight=mm2pt(6);
						var myWrapField = measurementEditboxes.add({editUnits:MeasurementUnits.MILLIMETERS,editValue:myInputHeight});
					}
				}
				//end borderpanel
			}
		}
	}
	//Display the dialog box.
	if(myDialog.show() == true){
		//If the user didnít click the Cancel button,
		//Get the size fields.
		gWidth = pt2mm(myWidthField.editValue);
		gHeight = pt2mm(myHeightField.editValue);
		gSpine = pt2mm(mySpineField.editValue);
		myBack = String(hbpb.selectedIndex);
		myFinish = myFinishSelection[mfs.selectedIndex];
		if(myBack == 1){ //Paperback=0 Hardback=1
			myBleed = 15;
		}else{
			myBleed = 5;
		}
		//Get sizes for flap
		myFlap = myFlapCheckbox.checkedState;
		fWidth = pt2mm(myFlapWidthField.editValue);
		wWidth = pt2mm(myWrapField.editValue);
		
		//where done with the dialog
		myDialog.destroy();
		
		//There is no need to create cropmarks with this setup
		createCoverFile(gWidth,gHeight,gSpine,myBleed,fWidth,wWidth,myFlap);
		
		//Set sizes in slug
		defineMeasureParagraphStyle(myCover);
		placeSizesInSlug(myCover,"measurements",myFinish);
		
		//Now let’s show the template so we can work it
		var myWindow = myCover.windows.add();
	}
	else{
		myDialog.destroy();
	}
}

//----------------------------------- E N D - D I A L O G

function createCoverFile(myWidth,myHeight,mySpineWidth,myBleed,fWidth,wWidth,myFlap){
	//Create a new doc and hides it’s window
	myCover = app.documents.add(true);
	
	//Set up the document.
	with(myCover.viewPreferences){
		horizontalMeasurementUnits = MeasurementUnits.millimeters;
		verticalMeasurementUnits = MeasurementUnits.millimeters;
		rulerOrigin = RulerOrigin.pageOrigin;
	}
	with(myCover.documentPreferences){
		facingPages = true;
		//Set horizontal and vertical measurement units to mm
		horizontalMeasurementUnits = MeasurementUnits.MILLIMETERS;
		verticalMeasurementUnits = MeasurementUnits.MILLIMETERS;
		//Size
		pageHeight = myHeight;
		pageWidth = myWidth;
		//Bleed & Slug
		documentBleedUniformSize = true;
		documentBleedTopOffset = myBleed;
		documentSlugUniformSize = true;
		slugTopOffset = myBleed+5;
		pagesPerDocument = 1;
	}
	
	if(myFlap == true){
		var myPages = 5;
	} else {
		var myPages = 3;
	}
	myCover.masterSpreads.add(myPages,{namePrefix:"AU", baseName:"cover"});
	with(myCover.masterSpreads.item("AU-cover")){
		for (i=0;i<=1;i++){
			with(pages.item(i)){
				with(marginPreferences){
					columnCount = 1;
					columnGutter = 0;
					bottom = "10mm"
					//left == inside; right == outside
					left = "10mm"
					right = "10mm"
					top = "10mm"
				}
			}
		}
	}
	
	//Create a new masterspread for spine
	myCover.masterSpreads.add(1,{namePrefix:"AU", baseName:"spine"});
	with(myCover.masterSpreads.item("AU-spine")){
		with(pages.item(0)){
			with(marginPreferences){
				columnCount = 1;
				columnGutter = 0;
				bottom = "10mm"
				//left == inside; right == outside
				left = "0mm"
				right = "0mm"
				top = "10mm"
			}
			//Set the spine width
			resize(CoordinateSpaces.INNER_COORDINATES,
				AnchorPoint.CENTER_ANCHOR,ResizeMethods.REPLACING_CURRENT_DIMENSIONS_WITH,
				//1 millimetre = 2.83464567 PostScript points
				[mySpineWidth*2.83464567, myHeight*2.83464567]);
		}
	}
	
	//Create a new masterspread for flap
	if(myFlap == true){
		myCover.masterSpreads.add(1,{namePrefix:"AU", baseName:"flap"});
		with(myCover.masterSpreads.item("AU-flap")){
			with(pages.item(0)){
				with(marginPreferences){
					columnCount = 1;
					columnGutter = 0;
					bottom = "10mm"
					//left == inside; right == outside
					left = "0mm"
					right = "0mm"
					top = "10mm"
				}
				//Set the flap width
				resize(CoordinateSpaces.INNER_COORDINATES,
					AnchorPoint.CENTER_ANCHOR,ResizeMethods.REPLACING_CURRENT_DIMENSIONS_WITH,
					//1 millimetre = 2.83464567 PostScript points
					[fWidth*2.83464567, myHeight*2.83464567]);
			}
		}
	}
	
	//apply spine & flaps to masterspread
	
	var myRepeat = 1;
	if(myFlap == true){
		myRepeat++;
		myCover.masterSpreads.item("AU-cover").pages.item(0).appliedMaster = myCover.masterSpreads.item("AU-flap");
		myCover.masterSpreads.item("AU-cover").pages.item(4).appliedMaster = myCover.masterSpreads.item("AU-flap");
	}
	myCover.masterSpreads.item("AU-cover").pages.item(myRepeat).appliedMaster = myCover.masterSpreads.item("AU-spine");
	
	//Do first spread
	var myCoverspead = myCover.spreads.item(0);
	myCoverspead.allowPageShuffle = false;
	
	for (i=1;i<=myRepeat;i++){
		myCover.pages.add(LocationOptions.AFTER,myCoverspead.pages.item(0));
		myCover.pages.add(LocationOptions.BEFORE,myCoverspead.pages.item(0));
	}
	for (j=0;j<=myCoverspead.pages.length-1;j++){
		myCoverspead.pages.item(j).appliedMaster = myCover.masterSpreads.item("AU-cover");
	}
	
	//remove A-master
	myCover.masterSpreads.item(0).remove();
	
}

function placeSizesInSlug(myCover,myParagraphStyle,myFinish){
	//top
	for (i=0;myCover.masterSpreads[0].pages.length>i;i++){
		var myPage = myCover.masterSpreads[0].pages.item(i);
		var pageBounds = myPage.bounds;
		var myPageWidth = doRound(pageBounds[3]-pageBounds[1], 2);
		var myFrameBounds = new Array (-myCover.documentPreferences.slugTopOffset,0,-myCover.documentPreferences.documentBleedTopOffset,myPageWidth);
		addTextFrame(myPage, myFrameBounds, myPageWidth.toString(), myParagraphStyle, 0);
		
	}
	
	//CVR1
	var mySpinePage = myCover.masterSpreads[0].pages.middleItem();
	var myPage = myCover.masterSpreads[0].pages.item(mySpinePage.index+1);
	var pageBounds = myPage.bounds;
	var myPageWidth = doRound(pageBounds[3]-pageBounds[1], 2);
	var myPageHeight = doRound(pageBounds[2]-pageBounds[0], 2);
	
	//bottom
	if(myFinish!="--No finish--"){
		var myFrameBounds = new Array (myPageHeight+myCover.documentPreferences.documentBleedBottomOffset,0,myPageHeight+myCover.documentPreferences.slugBottomOffset,myPageWidth);
		addTextFrame(myPage, myFrameBounds, "+ "+myFinish, myParagraphStyle, 0);
	}
	
	//right
	var myPage = myCover.masterSpreads[0].pages.lastItem();
	var pageBounds = myPage.bounds;
	var myPageWidth = doRound(pageBounds[3]-pageBounds[1], 2);
	var myPageHeight = doRound(pageBounds[2]-pageBounds[0], 2);
	
	//wierd bug in indesign 7.0.4, you proberbly have to remove this code when it’s fixed
	var myPrevPage = myCover.masterSpreads[0].pages.item(myPage.index-1);
	var pagePrevBounds = myPrevPage.bounds;
	var myPrevPageWidth = pagePrevBounds[3]-pagePrevBounds[1];
	myPageWidth+=myPrevPageWidth;
	//end wierd bug

	var myFrameBounds = new Array (0,myPageWidth+myCover.documentPreferences.documentBleedOutsideOrRightOffset,myPageHeight,myPageWidth+myCover.documentPreferences.slugRightOrOutsideOffset);
	addTextFrame(myPage, myFrameBounds, myPageHeight.toString(), myParagraphStyle, 270);

}

function defineMeasureParagraphStyle(myCover){
	measureParagraphStyle = myCover.paragraphStyles.add({name:"measurements"});
    try {
	measureParagraphStyle.appliedFont = "Helvetica";
    }
    catch(er) {
        measureParagraphStyle.appliedFont = "Arial";
        }
	measureParagraphStyle.pointSize = "8pt";
	measureParagraphStyle.fillColor = "Registration";
	measureParagraphStyle.fillTint = 100;
	measureParagraphStyle.justification = 1667591796;
}

function addTextFrame(myPage, myBounds, myString, myParagraphStyle, myRotationAngle){
	var myTextFrame = myPage.textFrames.add();
	myTextFrame.textFramePreferences.verticalJustification = VerticalJustification.CENTER_ALIGN;
	myTextFrame.rotationAngle = myRotationAngle;
	myTextFrame.geometricBounds = [myBounds[0], myBounds[1], myBounds[2], myBounds[3]];
	myTextFrame.contents = myString;
	myTextFrame.paragraphs[0].appliedParagraphStyle = myParagraphStyle;
}

function doRound(myNum, roundDec) {
	var roundMulit = Math.pow(10,roundDec);
	return Math.round(myNum*roundMulit)/roundMulit;
}

function mm2pt(myMmNum){
	//1 millimetre = 2.83464567 PostScript points
	return myMmNum*2.83464567;
}
function pt2mm(myMmNum){
	//1 millimetre = 2.83464567 PostScript points
	return myMmNum/2.83464567;
}